////////////////////////////////////////////////////////////////////////////
//
//  CODOCE_CONFIG.PAS
//
//  Stellt einen Konfigurations Dialog fr einen Codec dar.
//  Leider ist dieser Dialog noch nicht in die Demos integriert
//
//	Autor 	  : Rene Bllhoff
//  Erstellt  : Mrz 2007
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de -
////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////
unit codec_config;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,

  codec_interface;

type

  TfrmCodecCtrl = class(TForm)
    pnLineIn: TPanel;
    pnCodecCtrl: TPanel;
    pnHeadphone: TPanel;
    lbCodecCtrl: TLabel;
    lbLinein: TLabel;
    lbHeadphone: TLabel;
    tbLLineIn: TTrackBar;
    tbRLineIn: TTrackBar;
    tbLHPLevel: TTrackBar;
    tbRHPLevel: TTrackBar;
    cbLLineMute: TCheckBox;
    cbRLineMute: TCheckBox;
    btReset: TButton;
    cbHPLMute: TCheckBox;
    cbHPRMute: TCheckBox;
    cbBypass: TCheckBox;
    cbMicSel: TCheckBox;
    cbMicBoost: TCheckBox;
    cbLRSwap: TCheckBox;
    procedure cbBypassClick(Sender: TObject);
    procedure tbLLineInChange(Sender: TObject);
    procedure cbLLineMuteClick(Sender: TObject);
    procedure cbLRSwapClick(Sender: TObject);
    procedure btResetClick(Sender: TObject);
    procedure tbLHPLevelChange(Sender: TObject);
    procedure cbHPLMuteClick(Sender: TObject);
  private

  public

    codec : TCodecInterface;

  end;

  TCodecDialog = class (TComponent)
  private
    frmDialog : TfrmCodecCtrl;
  public
    constructor Create (Aowner : TComponent; codec : TCodecInterface);
    destructor Destroy;

    procedure Execute;
  end;


procedure ConfigCodec (codec : TCodecInterface);

var
  frmCodecCtrl: TfrmCodecCtrl;

implementation

{$R *.dfm}

procedure ConfigCodec (codec : TCodecInterface);
var cd : TCodecDialog;
begin
  cd := TCodecDialog.Create (nil, codec);
  cd.Execute;
  cd.destroy;
end;



constructor TCodecDialog.Create (Aowner : TComponent; codec : TCodecInterface);
begin
  inherited Create (aowner);
  frmDialog := TfrmCodecCtrl.create (self);
  frmdialog.codec := codec;
end;

destructor TCodecDialog.Destroy;
begin
  frmDialog.Destroy;
  inherited;
end;

procedure TCodecDialog.Execute;
begin
  frmDialog.ShowModal;
end;






procedure TfrmCodecCtrl.btResetClick(Sender: TObject);
begin
  codec.ResetCodec;
end;

procedure TfrmCodecCtrl.cbBypassClick(Sender: TObject);
begin
  if codec <> NIL then
  begin
    if cbBypass.Checked then codec.CodecRegister [4] := codec.CodecRegister [4] or 8
                        else codec.CodecRegister [4] := codec.CodecRegister [4] and not 8
  end;
end;

procedure TfrmCodecCtrl.cbHPLMuteClick(Sender: TObject);
begin
  if sender = cbHPLMute then tbLHPLevelChange (tbLHPLevel);
  if sender = cbHPRMute then tbLHPLevelChange (tbRHPLevel);
end;

procedure TfrmCodecCtrl.cbLLineMuteClick(Sender: TObject);
begin
  if codec <> NIL then
  begin
    if sender = cbLLineMute then
    begin
      if cbLLineMute.Checked then codec.CodecRegister [0] := codec.CodecRegister [0] or 128
                             else codec.CodecRegister [0] := codec.CodecRegister [0] and not 128;
    end;

    if sender = cbRLineMute then
    begin
      if cbRLineMute.Checked then codec.CodecRegister [1] := codec.CodecRegister [1] or 128
                             else codec.CodecRegister [1] := codec.CodecRegister [1] and not 128;
    end;

  end;
end;

procedure TfrmCodecCtrl.cbLRSwapClick(Sender: TObject);
begin
  if codec <> NIL then
  begin
    if cbLRSwap.Checked then codec.CodecRegister [7] := codec.CodecRegister [7] or 32
                        else codec.CodecRegister [7] := codec.CodecRegister [7] and not 32;
  end;
end;

procedure TfrmCodecCtrl.tbLHPLevelChange(Sender: TObject);
begin
  if codec <> NIL then
  begin
    if sender = tbLHPLevel then
    begin
      if cbHPLMute.checked then
        begin
          codec.codecregister [2] := $12f;
        end
      else
        begin
          codec.codecregister [2] := $12f + (50 - tbLHPLevel.position);
        end;
    end;

    if sender = tbRHPLevel then
    begin
      if cbHPRMute.checked then
        begin
          codec.codecregister [3] := $12f;
        end
      else
        begin
          codec.codecregister [3] := $12f + (50 - tbRHPLevel.position);
        end;
    end;

  end;
end;

procedure TfrmCodecCtrl.tbLLineInChange(Sender: TObject);
begin
  if codec <> NIL then
  begin
    if sender = tbLLineIn then codec.CodecRegister [0] := (codec.CodecRegister [0] and not $1f) or (31 - tbLLineIn.Position);
    if sender = tbRLineIn then codec.CodecRegister [1] := (codec.CodecRegister [1] and not $1f) or (31 - tbRLineIn.Position);
  end;
end;




end.
