////////////////////////////////////////////////////////////////////////////
//
//  SIMPLE_CTRLS.PAS
//
//
//	Autor 	  : Rene Bllhoff
//  Erstellt  : April 2007
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de -
////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////
unit simple_ctrls;

interface

uses
  SysUtils, Classes, Graphics, Controls, ExtCtrls, math;

type
  TPotiNotify = procedure (sender : tobject; val : single) of object;

  TSimplePoti = class (TImage)
  private
    md : boolean;
    vl : single;

    procedure DrawPot (angle : single);
    procedure omd (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure omu (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure omm (Sender: TObject; Shift: TShiftState; X, Y: Integer);
  public
    OnNotify : TPotiNotify;

    constructor Create (aowner : TComponent);
    destructor  Destroy;

    property    Value : single read vl write drawpot;

  end;

implementation



constructor TSimplePoti.Create (aowner : TComponent);
begin
  inherited Create (aowner);
  width := 30; height := 30;
  OnMouseDown := omd;
  OnMouseUp   := omu;
  OnMouseMove := omm;
  DrawPot(0);
end;

destructor  TSimplePoti.Destroy;
begin
  inherited;
end;

procedure TSimplePoti.DrawPot (angle : single);
var x1,y1,x2,y2:integer;
begin
  canvas.Brush.Color := clBtnFace;
  canvas.Pen.Color   := clBtnFace;
  canvas.Rectangle(0, 0, 30, 30);
  canvas.Pen.Color   := clBlack;
  canvas.Ellipse(0, 0, 30,30);
  angle := min (1, max (0, angle));
  vl    := angle;
  angle := 0.75 * angle;
  angle := angle - 0.375;
  angle := angle * 2 * pi;
  x1    := trunc (15 +  6 * sin (angle));
  y1    := trunc (15 -  6 * cos (angle));
  x2    := trunc (15 + 12 * sin (angle));
  y2    := trunc (15 - 12 * cos (angle));
  canvas.moveto (x1, y1);
  canvas.lineto (x2, y2);
end;


procedure TSimplePoti.omd (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  md := true;
end;

procedure TSimplePoti.omu (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  md := false;
end;

procedure TSimplePoti.omm (Sender: TObject; Shift: TShiftState; X, Y: Integer);
var rx, ry, r, a, b : single;
begin
  if md then
  begin
    rx := x - (width div 2);
    ry := y - (width Div 2) + 3;

    r  := sqrt (sqr (rx) + sqr (ry));
    if r = 0 then r := 1;

    a := (arccos (ry / r)) * 180 / PI;
    b := (arcsin (rx / r)) * 180 / PI;

    if b > 0   then a := 360 - a;

    if a > 315 then a := 315;
    if a <  45 then a :=  45;

    DrawPot ((a-45)/270);
    if @OnNotify <> NIL then OnNotify (self, vl);
  end;
end;



end.
