////////////////////////////////////////////////////////////////////////////
//
//  STR_FUNCS.PAS
//
//  Ntzliche Funktionen
//
//
//	Autor 	  : Rene Bllhoff
//  Erstellt  : Mrz 2007
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de -
////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////
unit strfuncs;

interface

uses sysutils, math, dialogs, classes;

procedure info              (x : ansistring);

function  ClearSpaces       (x : ansistring) : ansistring;
function  GetUntil          (x : ansistring; sc : char; var rest : ansistring) : ansistring;
function  GetUntilwoSP      (x : ansistring; sc : char; var rest : ansistring) : ansistring;

function  GetNextTagName    (x : ansistring) : ansistring;
function  CutTag            (var x : ansistring; tag : string) : ansistring;
function  MakeTag           (tag : string; x : ansistring) : ansistring;

implementation

// einfach info-dialog anzeigen
procedure info              (x : ansistring);
begin
  messagedlg (x, mtinformation, [mbok], 0);
end;


function  ClearSpaces       (x : ansistring) : ansistring;
var st, en, l : word;
    c         : char;
begin
  result := '';
  if x <> '' then
  begin
    l  := length (x);
    st := 1;
    en := l;
    repeat
      c := x [st];
      if c = ' ' then inc (st);
    until (st > l) or (c <> ' ');

    if st <= l then
      repeat
        c := x [en];
        if c = ' ' then dec (en);
      until (en = 0) or (c <> ' ');

    if (en >= st) then result := copy (x, st, en - st + 1);
  end;
end;

// string beim ersten zeichen sc aufspalten
// (result = anfang - zeichen; rest = zeichen - ende; zeichen wird nicht zurckgegebn)
function  GetUntil          (x : ansistring; sc : char; var rest : ansistring) : ansistring;
var c : word;
begin
  result := '';
  rest   := '';
  // is was da ?
  if x <> '' then
  begin
    // zeichen sc vorhanden ?
    c := pos (sc, x);
    if (c <> 0) then
      begin
        if c = 1 then rest := copy (x, c + 1, length (x))
                 else begin
                        result := copy (x, 1, c - 1);
                        rest   := copy (x, c + 1, length (x));
                      end;
      end
    else
      // kein sc dann komplett result & rest = ''
      result := x;
  end;
end;

function  GetUntilwoSP      (x : ansistring; sc : char; var rest : ansistring) : ansistring;
begin
  result := clearspaces (getuntil (x, sc, rest)); rest := clearspaces (rest); 
end;


function CutTag (var x : ansistring; tag : string) : ansistring;
var st, et  : string;
    sp, ep  : longint;
    a, b, c : ansistring;
begin
  st := format ('<%s>', [tag]);
  et := format ('</%s>', [tag]);
  sp := pos (st, x); ep := pos (et, x);
  if (sp <> 0) and (ep <> 0) and (ep > sp) then
  begin
    a := copy (x,  1, sp - 1);
    b := copy (x, sp + length (st), ep - sp - length (st));
    c := copy (x, ep + length (et), length (x) - ep - 1);

    x := a + c;
    result := b;
  end;
end;

function  MakeTag           (tag : string; x : ansistring) : ansistring;
begin
  result := format ('<%s>%s</%s>', [tag, x, tag]);
end;

function GetNextTagName (x : ansistring) : ansistring;
var vp1, vp2, vp3 : integer;
begin
  vp1 := pos ('<', x);
  vp2 := pos ('>', x);
  vp3 := pos ('</', x);
  if (vp1 <> 0) and (vp2 <> 0) and (vp1 <> vp3) and (vp2 > vp1) then
    result := copy (x, vp1 + 1, vp2 - vp1 - 1)
  else
    result := '';
end;


end.
