////////////////////////////////////////////////////////////////////////////
//
//  SYNTH_DEMO.PAS
//
//
//	Autor 	  : Rene Bllhoff
//  Erstellt  : Mrz 2007
//
//	(c) 2005-2007 by Rene Bllhoff - reneboellhoff (at) gmx (dot) de -
////////////////////////////////////////////////////////////////////////////
//
//  This source file may be used and distributed without
//  restriction provided that this copyright statement is not
//  removed from the file and that any derivative work contains
//  the original copyright notice and the associated disclaimer.
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU
//  General Public License for more details.
//
//  You should have received a copy of the GNU General Public
//  License along with this source; if not, download it	from
//  http://www.gnu.org/licenses/gpl.html
//
////////////////////////////////////////////////////////////////////////////
unit synth_demo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, math,


  comselect,
  fpga_com_base,

  fpga_dap, codec_interface,
  coeffs, synthtools,

  synth_demo_util, simple_ctrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    tmMain: TTimer;
    pnSynth: TPanel;
    pnOscillators: TPanel;
    lbHdOsc2: TLabel;
    pnFilter2: TPanel;
    lbHdFilter2: TLabel;
    lbHdFilterCut: TLabel;
    lbValFilterCut: TLabel;
    lbHdFilterRes: TLabel;
    lbValFilterRes: TLabel;
    pnPotiFilterCut: TPanel;
    pnPotiFilterRes: TPanel;
    cbFilterType: TComboBox;
    pnEnvelope2: TPanel;
    lbHdEnvA: TLabel;
    lbValEnvA: TLabel;
    lbHdEnvelope2: TLabel;
    lbHdEnvD: TLabel;
    lbValEnvD: TLabel;
    lbHdEnvS: TLabel;
    lbValEnvS: TLabel;
    lbHdEnvR: TLabel;
    lbValEnvR: TLabel;
    lbHdVolume: TLabel;
    lbValVolume: TLabel;
    pnPotiEnvA: TPanel;
    pnPotiEnvD: TPanel;
    pnPotiEnvS: TPanel;
    pnPotiEnvR: TPanel;
    pnPotiVolume: TPanel;
    pnOsc1: TPanel;
    cbOsc1Wave: TComboBox;
    lbValOsc1Tune: TLabel;
    lbValOsc1PWM: TLabel;
    lbValOsc1Level: TLabel;
    pnPotiOsc1Level: TPanel;
    lbHdOsc1Level: TLabel;
    lbHdOsc1PWM: TLabel;
    pnPotiOsc1PWM: TPanel;
    pnPotiOsc1Tune: TPanel;
    lbHdOsc1Tune: TLabel;
    pnOsc3: TPanel;
    pnOsc2: TPanel;
    cbOsc2Wave: TComboBox;
    lbValOsc2Tune: TLabel;
    pnPotiOsc2Tune: TPanel;
    lbHdOsc2Tune: TLabel;
    lbHdOsc2PWM: TLabel;
    pnPotiOsc2PWM: TPanel;
    lbValOsc2PWM: TLabel;
    lbValOsc2Level: TLabel;
    pnPotiOsc2Level: TPanel;
    lbHdOsc2Level: TLabel;
    cbOsc3Wave: TComboBox;
    lbValOsc3Tune: TLabel;
    pnPotiOsc3Tune: TPanel;
    lbHdOsc3Tune: TLabel;
    lbHdOsc3PWM: TLabel;
    pnPotiOsc3PWM: TPanel;
    lbValOsc3PWM: TLabel;
    lbValOsc3Level: TLabel;
    pnPotiOsc3Level: TPanel;
    lbHdOsc3Level: TLabel;
    Panel1: TPanel;
    pnSeq: TPanel;
    lbHdSeq: TLabel;
    lbSeqVal01: TLabel;
    lbSeqVal02: TLabel;
    lbSeqVal03: TLabel;
    lbSeqVal04: TLabel;
    lbSeqVal05: TLabel;
    lbSeqVal06: TLabel;
    lbSeqVal07: TLabel;
    lbSeqVal08: TLabel;
    lbSeqVal16: TLabel;
    lbSeqVal15: TLabel;
    lbSeqVal14: TLabel;
    lbSeqVal13: TLabel;
    lbSeqVal12: TLabel;
    lbSeqVal11: TLabel;
    lbSeqVal10: TLabel;
    lbSeqVal09: TLabel;
    tbSeqlevel02: TTrackBar;
    tbSeqlevel04: TTrackBar;
    tbSeqlevel03: TTrackBar;
    tbSeqlevel14: TTrackBar;
    tbSeqlevel05: TTrackBar;
    tbSeqlevel13: TTrackBar;
    tbSeqlevel06: TTrackBar;
    tbSeqlevel07: TTrackBar;
    tbSeqlevel08: TTrackBar;
    tbSeqlevel09: TTrackBar;
    tbSeqlevel10: TTrackBar;
    tbSeqlevel11: TTrackBar;
    tbSeqlevel12: TTrackBar;
    tbSeqlevel15: TTrackBar;
    tbSeqlevel01: TTrackBar;
    tbSeqlevel16: TTrackBar;
    rbSeqPortGate: TRadioButton;
    rbSeqPortTone: TRadioButton;
    rbSeqPortCtrl: TRadioButton;
    Edit1: TEdit;
    UpDown1: TUpDown;
    Button4: TButton;
    pnSynthControl: TPanel;
    Label10: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure tmMainTimer(Sender: TObject);
    procedure tbSeqlevel01Change(Sender: TObject);
    procedure rbSeqPortGateClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure rbSimpleGateClick(Sender: TObject);
    procedure cbOsc1WaveClick(Sender: TObject);
    procedure cbFilterTypeChange(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }


    fpga    : TFPGACOMBase;
    dap     : TFPGADAP;

    codec1  : TCodecInterface;
    codec2  : TCodecInterface;

    run     : boolean;


    data_initialize : boolean;

    seq_portion : byte;

    ignore_tb : boolean;

    syncore : TSynthCtrlCore;


    pot_osc1tune, pot_osc1pwm, pot_osc1lev  : TSimplePoti;
    pot_osc2tune, pot_osc2pwm, pot_osc2lev  : TSimplePoti;
    pot_osc3tune, pot_osc3pwm, pot_osc3lev  : TSimplePoti;


    pot_filtcut , pot_filtres               : TSimplePoti;


    pot_enva    , pot_envd                  : TSimplePoti;
    pot_envs    , pot_envr                  : TSimplePoti;
    pot_volume                              : TSimplePoti;


    procedure InitDAPProgram;


    procedure collectpotinotifes (sender : tobject; val : single);

    procedure SetSeqPortion (x : byte);

    procedure ReadFromSynthCore;


    function GetSeqLevelTrackBar  (x : integer) : TTRackBar;
    function GetSeqLevelLabel     (x : integer) : TLabel;


  end;



var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var cp, br : integer;
begin
  DecimalSeparator := '.';  // wichtig fr val

  fpga  := TFPGACOMBase.Create;

  cp := 1;
  br := fpgacom_baudrate;

  if ComPortSelect (cp, br) then fpga.OpenPort(cp);

  codec1    := TCodecInterface.Create (fpga, 0);
  codec2    := TCodecInterface.Create (fpga, 1);

  dap       := TFPGADAP.Create (fpga);
  dap.Port  := $f1;

  syncore   := TSynthCtrlCore.Create;

  syncore.dap := dap;

  syncore.BasePitch := 33;

  data_initialize := true;

  ignore_tb := true;





  pot_osc1tune  := TSimplePoti.create (pnPotiOsc1Tune );
  pot_osc1pwm   := TSimplePoti.create (pnPotiOsc1PWM  );
  pot_osc1lev   := TSimplePoti.create (pnPotiOsc1Level);
  pot_osc2tune  := TSimplePoti.create (pnPotiOsc2Tune );
  pot_osc2pwm   := TSimplePoti.create (pnPotiOsc2PWM  );
  pot_osc2lev   := TSimplePoti.create (pnPotiOsc2Level);
  pot_osc3tune  := TSimplePoti.create (pnPotiOsc3Tune );
  pot_osc3pwm   := TSimplePoti.create (pnPotiOsc3PWM  );
  pot_osc3lev   := TSimplePoti.create (pnPotiOsc3Level);
  pot_filtcut   := TSimplePoti.create (pnPotiFilterCut);
  pot_filtres   := TSimplePoti.create (pnPotiFilterRes);
  pot_enva      := TSimplePoti.create (pnPotiEnvA     );
  pot_envd      := TSimplePoti.create (pnPotiEnvD     );
  pot_envs      := TSimplePoti.create (pnPotiEnvS     );
  pot_envr      := TSimplePoti.create (pnPotiEnvR     );
  pot_volume    := TSimplePoti.create (pnPotiVolume   );

  pnPotiOsc1Tune  .InsertControl (pot_osc1tune);
  pnPotiOsc1PWM   .InsertControl (pot_osc1pwm );
  pnPotiOsc1Level .InsertControl (pot_osc1lev );
  pnPotiOsc2Tune  .InsertControl (pot_osc2tune);
  pnPotiOsc2PWM   .InsertControl (pot_osc2pwm );
  pnPotiOsc2Level .InsertControl (pot_osc2lev );
  pnPotiOsc3Tune  .InsertControl (pot_osc3tune);
  pnPotiOsc3PWM   .InsertControl (pot_osc3pwm );
  pnPotiOsc3Level .InsertControl (pot_osc3lev );
  pnPotiFilterCut .InsertControl (pot_filtcut );
  pnPotiFilterRes .InsertControl (pot_filtres );
  pnPotiEnvA      .InsertControl (pot_enva    );
  pnPotiEnvD      .InsertControl (pot_envd    );
  pnPotiEnvS      .InsertControl (pot_envs    );
  pnPotiEnvR      .InsertControl (pot_envr    );
  pnPotiVolume    .InsertControl (pot_volume  );

  pot_osc1tune    .Tag := $0101;
  pot_osc1pwm     .Tag := $0102;
  pot_osc1lev     .Tag := $0103;
  pot_osc2tune    .Tag := $0201;
  pot_osc2pwm     .Tag := $0202;
  pot_osc2lev     .Tag := $0203;
  pot_osc3tune    .Tag := $0301;
  pot_osc3pwm     .Tag := $0302;
  pot_osc3lev     .Tag := $0303;
  pot_filtcut     .Tag := $0401;
  pot_filtres     .Tag := $0402;
  pot_enva        .Tag := $0501;
  pot_envd        .Tag := $0502;
  pot_envs        .Tag := $0503;
  pot_envr        .Tag := $0504;
  pot_volume      .Tag := $0601;


  pot_osc1tune    .OnNotify := collectpotinotifes;
  pot_osc1pwm     .OnNotify := collectpotinotifes;
  pot_osc1lev     .OnNotify := collectpotinotifes;
  pot_osc2tune    .OnNotify := collectpotinotifes;
  pot_osc2pwm     .OnNotify := collectpotinotifes;
  pot_osc2lev     .OnNotify := collectpotinotifes;
  pot_osc3tune    .OnNotify := collectpotinotifes;
  pot_osc3pwm     .OnNotify := collectpotinotifes;
  pot_osc3lev     .OnNotify := collectpotinotifes;
  pot_filtcut     .OnNotify := collectpotinotifes;
  pot_filtres     .OnNotify := collectpotinotifes;
  pot_enva        .OnNotify := collectpotinotifes;
  pot_envd        .OnNotify := collectpotinotifes;
  pot_envs        .OnNotify := collectpotinotifes;
  pot_envr        .OnNotify := collectpotinotifes;
  pot_volume      .OnNotify := collectpotinotifes;




    (*

  tbOscPitch1.Position := - ( 0);
  tbOscPitch2.Position := - ( 2);
  tbOscPitch3.Position := - (-2);

  tbOscPWM1.Position   := 255 - 64;
  tbOscPWM2.Position   := 255 - 128;
  tbOscPWM3.Position   := 255 - 204;

  tbOscLevel1.Position := 255 - $30;
  tbOscLevel2.Position := 255 - $30;
  tbOscLevel3.Position := 255 - $30;

  rbOsc1WaveSaw.Checked := true;
  rbOsc2WaveSaw.Checked := true;
  rbOsc3WaveSaw.Checked := true;


  tbenvelopea.Position := 1000 -   5;
  tbenveloped.Position := 1000 - 100;
  tbenvelopes.Position := 1000 -  50;
  tbenveloper.Position := 1000 - 100;



  tbFilterCutoff.Position := 1200 - 700;
  tbFilterRes.Position    := - (20);

  rbFilterLowPass.Checked := true;

  rbSimpleGate.Checked := true;
            *)       
  InitDAPProgram;  

  DAPWriteWTSine (dap);
  DAPWriteWTtri  (dap);
  DAPWriteWTSQR  (dap);



  run := false;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
  run := true;
  if data_initialize then
  begin
    rbSeqPortGate.checked := true;
    SetSeqPortion (0);


    data_initialize := false;



  end;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  dap.Destroy;
  fpga.destroy;
end;

procedure TForm1.InitDAPProgram;
begin
  // cmem map :
  // 0x00  osc 1 level
  // 0x01  osc 2 level
  // 0x02  osc 3 level
  // 0x03  output level
  // 0x04  filter 1



  dap.PMEM_StartProgram;

  dap.PMEM_Osc    (            DAP_OUT_UC_1, $00      );
  dap.PMEM_Shaper ( DAP_IN_UC, DAP_OUT_UC_1, $02      );
  dap.PMEM_Volume ( DAP_IN_UC, DAP_OUT_SC_1, $00      );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_1, $00      );

  dap.PMEM_Osc    (            DAP_OUT_UC_1, $04      );
  dap.PMEM_Shaper ( DAP_IN_UC, DAP_OUT_UC_1, $06      );
  dap.PMEM_Volume ( DAP_IN_UC, DAP_OUT_SC_1, $01      );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_1, $01      );

  dap.PMEM_Osc    (            DAP_OUT_UC_1, $08      );
  dap.PMEM_Shaper ( DAP_IN_UC, DAP_OUT_UC_1, $0a      );
  dap.PMEM_Volume ( DAP_IN_UC, DAP_OUT_SC_1, $02      );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_1, $02      );


  dap.PMEM_ClrSum (            DAP_OUT_SC_1           );
  dap.PMEM_AddMem (            DAP_OUT_SC_1,      $00 );
  dap.PMEM_AddMem (            DAP_OUT_SC_1,      $01 );
  dap.PMEM_AddMem (            DAP_OUT_SC_1,      $02 );
  dap.PMEM_Nop    ( DAP_IN_SC, DAP_OUT_SC_1           );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_1, $03      );

  dap.PMEM_Load   (            DAP_OUT_SC_1,      $03 );
  dap.PMEM_Load   (            DAP_OUT_SC_2,      $03 );


  dap.PMEM_Load   (            DAP_OUT_SC_1,      $03 );
  dap.PMEM_Biquad ( DAP_IN_SC, DAP_OUT_SC_1, $10, $04 );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_2, $04      );

  dap.PMEM_Load   (            DAP_OUT_SC_1,      $04 );
  dap.PMEM_Volume ( DAP_IN_SC, DAP_OUT_SC_1,      $03 );
  dap.PMEM_Store  ( DAP_IN_SC, DAP_OUT_SC_2, $05      );


  dap.PMEM_ClrSum (            DAP_OUT_SC_1           );
  dap.PMEM_AddInp ( DAP_IN_1,  DAP_OUT_SC_1           );
  dap.PMEM_AddMem (            DAP_OUT_SC_1,      $05 );
  dap.PMEM_Nop    ( DAP_IN_SC, DAP_OUT_SC_1           );

  dap.PMEM_ClrSum (            DAP_OUT_SC_2           );
  dap.PMEM_AddInp ( DAP_IN_2,  DAP_OUT_SC_2           );
  dap.PMEM_AddMem (            DAP_OUT_SC_2,      $05 );
  dap.PMEM_Nop    ( DAP_IN_SC, DAP_OUT_SC_2           );


  dap.PMEM_Load   (            DAP_OUT_SC_3,      $05 );
  dap.PMEM_Load   (            DAP_OUT_SC_4,      $05 );

  dap.PMEM_EndProgram;

end;



procedure TForm1.rbSeqPortGateClick(Sender: TObject);
begin
 if sender = rbSeqportGate then SetSeqPortion (0);
 if sender = rbSeqportTone then SetSeqPortion (1);
 if sender = rbSeqportCtrl then SetSeqPortion (2);
end;

procedure TForm1.rbSimpleGateClick(Sender: TObject);
begin
  if sender = RadioButton1 then syncore.CV_Source := 1;
  if sender = RadioButton2 then syncore.CV_Source := 2;
  if sender = RadioButton3 then syncore.CV_Source := 0;
end;
















procedure TForm1.UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
begin
  syncore.SeqPrescaler := UpDown1.Position;
end;

procedure TForm1.tmMainTimer(Sender: TObject);
begin
  if run then
  begin
    syncore.DoSynthCore;
  end;
end;


function TForm1.GetSeqLevelTrackBar (x : integer) : TTRackBar;
begin
  result := NIL;
  case x  of
    0 : result := tbSeqLevel01;
    1 : result := tbSeqLevel02;
    2 : result := tbSeqLevel03;
    3 : result := tbSeqLevel04;
    4 : result := tbSeqLevel05;
    5 : result := tbSeqLevel06;
    6 : result := tbSeqLevel07;
    7 : result := tbSeqLevel08;
    8 : result := tbSeqLevel09;
    9 : result := tbSeqLevel10;
   10 : result := tbSeqLevel11;
   11 : result := tbSeqLevel12;
   12 : result := tbSeqLevel13;
   13 : result := tbSeqLevel14;
   14 : result := tbSeqLevel15;
   15 : result := tbSeqLevel16;
  end;
end;


function TForm1.GetSeqLevelLabel (x : integer) : TLabel;
begin
  result := NIL;
  case x  of
    0 : result := lbSeqVal01;
    1 : result := lbSeqVal02;
    2 : result := lbSeqVal03;
    3 : result := lbSeqVal04;
    4 : result := lbSeqVal05;
    5 : result := lbSeqVal06;
    6 : result := lbSeqVal07;
    7 : result := lbSeqVal08;
    8 : result := lbSeqVal09;
    9 : result := lbSeqVal10;
   10 : result := lbSeqVal11;
   11 : result := lbSeqVal12;
   12 : result := lbSeqVal13;
   13 : result := lbSeqVal14;
   14 : result := lbSeqVal15;
   15 : result := lbSeqVal16;
  end;
end;


procedure TForm1.SetSeqPortion (x : byte);
var c: Integer;
    tb : TTrackBar;
    lb : TLabel;
begin
  if x < 3  then
  begin
    ignore_tb := true;
    seq_portion := x;
    for c := 0 to 15 do
    begin
      tb := GetSeqLevelTrackBar (c);
      case (seq_portion) of
        0 : tb.Position := trunc (1000 - (syncore.SeqencerGate [c] * 1000 ));
        1 : tb.Position := trunc (1000 - (500 * (1 + (syncore.SeqencerPitch [c] / 36.0))));
        2 : tb.Position := trunc (1000 - (syncore.SeqencerCtrl [c] * 1000 ));
      end;
      lb := GetSeqLevelLabel (c);
      case (seq_portion) of
        0 : lb.caption  := format ('%.0f', [syncore.SeqencerGate  [c] * 100]);
        1 : lb.caption  := format ('%.0f', [syncore.SeqencerPitch [c]]);
        2 : lb.caption  := format ('%.0f', [syncore.SeqencerCtrl  [c] * 100]);
      end;
    end;

    ignore_tb := false;
  end;
end;

procedure TForm1.tbSeqlevel01Change(Sender: TObject);
var tb : TTrackBar; c : integer; lb : TLabel;
begin
  if not ignore_tb then
  begin
    tb := TTrackbar (sender);
    c := tb.Tag;
    case (seq_portion) of
      0 : syncore.SeqencerGate  [c] := (1000 - tb.Position) / 1000;
      1 : syncore.SeqencerPitch [c] := trunc (2 * (((1000 - tb.Position) / 1000) - 0.5) * 36.0);
      2 : syncore.SeqencerCtrl  [c] := (1000 - tb.Position) / 1000;
    end;
    lb := GetSeqLevelLabel (c);
    case (seq_portion) of
      0 : lb.caption  := format ('%.0f', [syncore.SeqencerGate  [c] * 100]);
      1 : lb.caption  := format ('%.0f', [syncore.SeqencerPitch [c]]);
      2 : lb.caption  := format ('%.0f', [syncore.SeqencerCtrl  [c] * 100]);
    end;
  end;
end;

procedure TForm1.Button3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  syncore.ext_gate := 0.7;
end;

procedure TForm1.Button3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  syncore.ext_gate := 0.0;
end;






procedure TForm1.Button4Click(Sender: TObject);
begin
  if Button4.caption = 'Run' then Button4.caption := 'Stop'
                             else Button4.caption := 'Run';
  run := Button4.caption = 'Stop';
end;


procedure TForm1.ReadFromSynthCore;
begin

end;

procedure TForm1.cbFilterTypeChange(Sender: TObject);
begin
  syncore.FilterType := cbFilterType.ItemIndex;
end;

procedure TForm1.cbOsc1WaveClick(Sender: TObject);
var item : byte;
begin
  item := (TSimplePoti (sender).Tag shr 0) and $ff;
  case item of
    1 : syncore.OscWave [1] := cbOsc1Wave.itemindex;
    2 : syncore.OscWave [2] := cbOsc2Wave.itemindex;
    3 : syncore.OscWave [3] := cbOsc3Wave.itemindex;
  end;
end;

procedure TForm1.collectpotinotifes (sender : tobject; val : single);
var part, item : byte;
begin
  part := (TSimplePoti (sender).Tag shr 8) and $ff;
  item := (TSimplePoti (sender).Tag shr 0) and $ff;

  case part of
    1  : begin
           if item = 1 then syncore.OscTune   [1] := ( (2 * (val - 0.5)) *  36);
           if item = 2 then syncore.OscPWM    [1] := val;
           if item = 3 then syncore.OscLevel  [1] := val;
         end;
    2  : begin
           if item = 1 then syncore.OscTune   [2] := ( (2 * (val - 0.5)) *  36);
           if item = 2 then syncore.OscPWM    [2] := val;
           if item = 3 then syncore.OscLevel  [2] := val;
         end;
    3  : begin
           if item = 1 then syncore.OscTune   [3] := ( (2 * (val - 0.5)) *  36);
           if item = 2 then syncore.OscPWM    [3] := val;
           if item = 3 then syncore.OscLevel  [3] := val;
         end;
    4  : begin
           if item = 1 then syncore.FilterCutoff  := val * 120;
           if item = 2 then syncore.FilterRes     := 2 * (val - 0.5);
         end;
    5  : begin
           if item = 1 then syncore.EnvA          := val * 1;
           if item = 2 then syncore.EnvD          := val * 1;
           if item = 3 then syncore.EnvS          := val    ;
           if item = 4 then syncore.EnvR          := val * 1;
         end;
    6  : begin
           if item = 1 then ;
         end;
  end;
end;


end.
