----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:53:08 06/15/2007 
-- Design Name: 
-- Module Name:    dap_nexys - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity dap_nexys is
    Port ( clk50m : in  STD_LOGIC;
           res : in  STD_LOGIC;
           bclk : in  STD_LOGIC;
           lrclk : in  STD_LOGIC;
           sdin1 : in  STD_LOGIC;
           sdin2 : in  STD_LOGIC;
           sdout1 : out  STD_LOGIC;
           sdout2 : out  STD_LOGIC;
           rx_in : in  STD_LOGIC;
           tx_out : out  STD_LOGIC;
           gpo_out : out  STD_LOGIC_VECTOR (3 downto 0);
					 
					 sram_addr	: out 	std_logic_vector (22 downto 0);
					 sram_data 	: inout std_logic_vector (15 downto 0);
					 sram_cs 		: out  	std_logic;
					 sram_adv 	: out  	std_logic;
					 sram_oe 		: out  	std_logic;
					 sram_ub 		: out  	std_logic;
					 sram_lb 		: out  	std_logic;
					 sram_we 		: out 	std_logic;
					 sram_cre		: out 	std_logic;
					 sram_clk 	: out  	std_logic;
					 sram_wait 	: in	 	std_logic;					 
					
					 digout : out  STD_LOGIC_VECTOR (3 downto 0);
					 segout : out  STD_LOGIC_VECTOR (7 downto 0);
					 ledout : out  STD_LOGIC_VECTOR (7 downto 0);
					 pbtn   : in   STD_LOGIC_VECTOR (2 downto 0);
					 swin   : in   STD_LOGIC_VECTOR (7 downto 0)
					);
end dap_nexys;

architecture Behavioral of dap_nexys is

	COMPONENT dap
	PORT(
		clk50m : IN std_logic;
		res : IN std_logic;
		spi_clk : IN std_logic;
		spi_di : IN std_logic;
		spi_cs : IN std_logic;
		bclk : IN std_logic;
		lrclk : IN std_logic;
		sdin1 : IN std_logic;
		sdin2 : IN std_logic;
		swin : IN std_logic_vector(7 downto 0);
		pbtn : IN std_logic_vector(2 downto 0);
		if_sel : IN std_logic;
		rx_in : IN std_logic;
		tx_uC : IN std_logic;          
		spi_do : OUT std_logic;
		sdout1 : OUT std_logic;
		sdout2 : OUT std_logic;
		ledout : OUT std_logic_vector(7 downto 0);
		segout : OUT std_logic_vector(7 downto 0);
		digout : OUT std_logic_vector(3 downto 0);
		tx_out : OUT std_logic;
		rx_uC : OUT std_logic;
		gpo_out : OUT std_logic_vector(3 downto 0);
		
		sram_addr	: out 	std_logic_vector (22 downto 0);
		sram_data : inout std_logic_vector (15 downto 0);
		sram_cs 	: out  	std_logic;
		sram_adv 	: out  	std_logic;
		sram_oe 	: out  	std_logic;
		sram_ub 	: out  	std_logic;
		sram_lb 	: out  	std_logic;
		sram_we 	: out 	std_logic;
		sram_cre	: out 	std_logic;
		sram_clk 	: out  	std_logic;
		sram_wait : in	 	std_logic
		);
	END COMPONENT;


begin



	Inst_dap: dap PORT MAP(
		clk50m 	=> clk50m,
		res 		=> res,
		spi_clk => '0',
		spi_do 	=> open,
		spi_di 	=> '0',
		spi_cs 	=> '0',
		bclk 		=> bclk,
		lrclk 	=> lrclk,
		sdin1 	=> sdin1,
		sdout1 	=> sdout1,
		sdin2 	=> sdin2,
		sdout2 	=> sdout2,
		swin 		=> swin,
		pbtn 		=> pbtn,
		--ledout 	=> open,
		ledout 	=> ledout,
		segout 	=> segout,
		digout 	=> digout,
		if_sel 	=> '0',
		rx_in 	=> rx_in,
		tx_out 	=> tx_out,
		rx_uC 	=> open,
		tx_uC 	=> '0',
		gpo_out => gpo_out,
		
		sram_addr	=> sram_addr,
		sram_data => sram_data, 
		sram_cs 	=> sram_cs 	,
		sram_adv 	=> sram_adv ,	
		sram_oe 	=> sram_oe 	,
		sram_ub 	=> sram_ub 	,
		sram_lb 	=> sram_lb 	,
		sram_we 	=> sram_we 	,
		sram_cre	=> sram_cre	,
		sram_clk 	=> sram_clk ,
		sram_wait => sram_wait 
	);


	--ledout (7 downto 1) <= (others => '0');
	--ledout (0) <= rx_in;

end Behavioral;

